---
name: New challenge proposal
about: Submit a new challenge to ToberQuizz
title: New challenge proposal for [Country]
labels: ''
assignees: Tobertet

---

# Checklist

- [ ] The challenge complies with the challenge rules.
- [ ] Answered the questionnaire.
- [ ] Included 256x256 minimal size images in PNG format inside a ZIP with the question number as filename.
- [ ] Included challenge data and hashed solutions using Argon2 with the required parameters.

(Only if the locale is not already in the app)

- [ ] Created a Pull Request with the locale translations.

# Challenge rules

- It must have between 20 and 30 questions.
- Images must comply with the source image license obligations.
- The content must not have anything that can be discriminating on the basis of race, color, national origin, sex, sexual identity, gender identity, religion or age.
- The content must be appropriate for children and must not contain drugs, pornography or explicit violence.

# Questionnaire

- For what country is the challenge?
- What is its topic/theme?
- How many people that start the challenge do you think will be able to complete it? In %.

# Challenge Resources

Go to [this wiki page](https://github.com/Tobertet/ToberQuizz/wiki/Proposing-a-new-challenge) for instructions on how to generate the images and data for the new challenge.

## Images

> Images must comply with the source image license obligations.

Please attach here a zip file with the proposed images for the new challenge.

## Data

Please attach here a json file with the proposed data for the new challenge.
